'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "gbdedupe.exe"
#Dim All
#Debug Error On
#Debug Display On
%Unicode=1
#Include "Win32API.inc"

#Resource Manifest, 1, "files\xptheme.xml"

#Resource Icon logo, "images\gbdedupe.ico"
#Resource Icon xlogo, "images\gbdedupes.ico"
#Resource Icon xcopy, "images\copy.ico"
#Resource Icon xsort, "images\sort.ico"
#Resource Icon xpaste, "images\paste.ico"
#Resource Icon xhelp, "images\help.ico"
#Resource Icon xfont, "images\font.ico"
#Resource Icon xmatch, "images\match.ico"
#Resource Icon xsaveas, "images\bluesave.ico"
#Resource Icon xopen, "images\open.ico"

$ver = "v1.0"
Enum Equates Singular
   IDT_DeDupe
   IDT_DeDupeS
   IDT_Open
   IDT_SaveAs
   IDT_CopyAll
   IDT_Paste
   IDT_CaseSensitive
   IDT_Sort
   IDT_Font
   IDT_Match
   IDT_Help

   IDC_Toolbar
   IDC_Source
   IDC_Results
   IDC_Statusbar

   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete
   IDM_Clear
   IDM_ClearBoth
   IDM_Sep

   IDM_LeftJustify
   IDM_RemoveBlankLines
   IDM_Trim
   IDM_TrimRight
   IDM_UpperCase
   IDM_LowerCase
   IDM_MixedCase
   IDM_RemoveExtraSpaces
   IDM_RemoveNumberedLines
   IDM_Replace
   IDM_ReplaceNonWordChars
   IDM_DeleteColumns
   IDM_Truncate
   IDM_Split
   IDM_SplitOnSpace
   IDM_FakeData
   IDM_SortA
   IDM_SortD
   IDM_AllowedChars
   IDM_Undo
   IDM_NumberLines
   IDM_UnNumberLines
   IDM_MultiTask
End Enum

Global hDlg,hToolbar,ghHook,hFont,hContext As Dword, tempList() As String
Global AllowedChars, FileFilter, SplitString, SearchString  As WStringZ * %Max_Path
Global ReplaceString, CFN, FontName As WStringZ * %Max_Path
Global UndoSource, UndoResults As String
Global CaseSensitive, OldProc, FontSize, FontAttr, StartColumn,StopColumn,TruncatePos As Long

Function PBMain() As Long
   Local style&
   style& = %WS_TabStop Or %WS_Border Or %WS_VScroll Or %WS_HScroll Or _
            %ES_Left Or %ES_WantReturn Or %ES_AutoHScroll Or %ES_AutoVScroll Or %ES_MultiLine
   Dialog New Pixels, 0, "gbDeDupe   " + $ver,300,300,400,300, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg, "logo"
   Control Add TextBox, hDlg, %IDC_Source,"", 10,55,150,200, style&, %WS_Ex_ClientEdge
   Control Add TextBox, hDlg, %IDC_Results,"", 180,55,150,200, style&, %WS_Ex_ClientEdge
   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local w,h,iResult As Long, temp$, P As TooltipText Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         SendMessage(GetDlgItem(hDlg,%IDC_Source),%EM_SetLimitText, 0,0)     'set new limit 2G
         SendMessage(GetDlgItem(hDlg,%IDC_Results),%EM_SetLimitText, 0,0)     'set new limit 2G
         BuildAcceleratorTable
         CreateToolbar
         CreateContextMenus
         Settings_ini "get"
         Font New FontName, FontSize, FontAttr To hFont
         SetControlFonts
         SetMenusAndToolbar
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Source), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Results), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
         LoadPreviousSession
         DisplaySummary

      Case %WM_Destroy
         SaveSession
         Settings_ini "save"
         SetWindowLong GetDlgItem(hDlg, %IDC_Source), %GWL_WNDPROC, OldProc   'un-subclass
         SetWindowLong GetDlgItem(hDlg, %IDC_Results), %GWL_WNDPROC, OldProc   'un-subclass

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_DeDupe To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
         End Select

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_Source
               If Cb.CtlMsg = %EN_Change Then DisplaySummary

            Case %IDC_Results
               If Cb.CtlMsg = %EN_Change Then DisplaySummary

            Case %IDT_Open
               SaveUndoText
               SelectFile
               DisplaySummary

            Case %IDT_Paste
               SaveUndoText
               Clipboard Get Text To temp$
               Control Set Text hDlg, %IDC_Source, temp$
               DisplaySummary

            Case %IDT_Sort
               SaveUndoText
               BuildTempList
               SortTextA
               DisplaySummary

            Case %IDT_DeDupe
               BuildTempList
               RemoveDupes (0)   '0 means not sort the output
               DisplaySummary

            Case %IDT_DeDupeS
               BuildTempList
               RemoveDupes (1)   '1 means sort the output
               DisplaySummary

            Case %IDT_CopyAll
               Control Get Text hDlg, %IDC_Results To temp$
               Clipboard Reset
               Clipboard Set Text temp$

            Case %IDT_SaveAs
               SaveAs

            Case %IDT_CaseSensitive
               CaseSensitive = CaseSensitive Xor 1
               SetMenusAndToolbar

            Case %IDT_Font
               SelectMainFont

            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbdedupe.htm"
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_Cut
               SaveUndoText
               SendMessage GetFocus, %WM_CUT, 0, 0    : DisplaySummary

            Case %IDM_Copy
               SendMessage GetFocus, %WM_COPY, 0, 0

            Case %IDM_Paste
               SaveUndoText
               SendMessage GetFocus, %WM_PASTE, 0, 0  : DisplaySummary

            Case %IDM_Delete
               SaveUndoText
               SendMessage GetFocus, %WM_CLEAR, 0, 0  : DisplaySummary

            Case %IDM_Clear
               SaveUndoText
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), ""
               DisplaySummary

            Case %IDM_ClearBoth
               Control Get Text hDlg, %IDC_Source To UndoSource
               Control Get Text hDlg, %IDC_Results To UndoResults
               Control Set Text hDlg, %IDC_Source, ""
               Control Set Text hDlg, %IDC_Results, ""
               DisplaySummary

            Case %IDM_FakeData
               SaveUndoText
               CreateFakeData
               DisplaySummary

            Case %IDM_SortA
               SaveUndoText
               BuildTempList
               SortTextA

            Case %IDM_SortD
               SaveUndoText
               BuildTempList
               SortTextD

            Case %IDM_LeftJustify
               SaveUndoText
               BuildTempList
               For w = 0 To UBound(tempList)
                  tempList(w) = LTrim$(tempList(w))
               Next w
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)

            Case %IDM_RemoveBlankLines
               SaveUndoText
               RemoveBlankLines
               DisplaySummary

            Case %IDM_Trim
               SaveUndoText
               BuildTempList
               For w = 0 To UBound(tempList)
                  tempList(w) = Trim$(tempList(w))
               Next w
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)

            Case %IDM_TrimRight
               SaveUndoText
               BuildTempList
               For w = 0 To UBound(tempList)
                  tempList(w) = RTrim$(tempList(w))
               Next w
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)

            Case %IDM_UpperCase
               SaveUndoText
               Control Get Text hDlg, GetDlgCtrlID(GetFocus) To temp$
               temp$ = UCase$(temp$)
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), temp$

            Case %IDM_LowerCase
               SaveUndoText
               Control Get Text hDlg, GetDlgCtrlID(GetFocus) To temp$
               temp$ = LCase$(temp$)
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), temp$

            Case %IDM_MixedCase
               SaveUndoText
               Control Get Text hDlg, GetDlgCtrlID(GetFocus) To temp$
               temp$ = MCase$(temp$)
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), temp$

            Case %IDM_RemoveExtraSpaces
               SaveUndoText
               Control Get Text hDlg, GetDlgCtrlID(GetFocus) To temp$
               temp$ = Shrink$(temp$)   '<---- also Trims
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), temp$

            Case %IDM_RemoveNumberedLines
               SaveUndoText
               RemoveNumberedLines
               DisplaySummary

            Case %IDM_Replace
               SaveUndoText
               ReplaceTextString
               DisplaySummary

            Case %IDM_ReplaceNonWordChars
               SaveUndoText
               ReplaceNonWordChars
               DisplaySummary

            Case %IDM_DeleteColumns
               SaveUndoText
               DeleteColumns
               DisplaySummary

            Case %IDM_Truncate
               SaveUndoText
               TruncateLines
               DisplaySummary

            Case %IDM_Split
               SaveUndoText
               SplitLines
               DisplaySummary

            Case %IDM_SplitOnSpace
               SaveUndoText
               SplitLinesOnSpace
               DisplaySummary

            Case %IDM_AllowedChars
               EditAllowedChars

            Case %IDM_Undo
               Select Case GetDlgCtrlID(GetFocus)
                  Case %IDC_Source  : Control Set Text hDlg, %IDC_Source, UndoSource
                  Case %IDC_Results : Control Set Text hDlg, %IDC_Results, UndoResults
               End Select

            Case %IDM_NumberLines
               SaveUndoText
               NumberLines

            Case %IDM_UnNumberLines
               SaveUndoText
               UnNumberLines

            Case %IDM_MultiTask
               Control Set Focus hDlg, %IDC_Source
               SaveUndoText
               BuildTempList
               For w = 0 To UBound(tempList)
                  tempList(w) = LTrim$(tempList(w))
               Next w
               Control Set Text hDlg, %IDC_Source, Join$(tempList(),$CrLf)
               RemoveDupes (1)   '1 means sort the output
               DisplaySummary

         End Select

      Case %WM_LButtonDblClk
         CreateFakeData
         DisplaySummary


      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Loc hDlg, %IDC_Results, w/2+5,55
         Control Set Size hDlg, %IDC_Results, w/2-15,h-80
         Control Set Size hDlg, %IDC_Source, w/2-15,h-80
   End Select
End Function

Sub BuildTempList
   'builds tempList() Global array, with text from textbox that has focus
   Local temp$, i As Long, cID As Long
   cID = GetDlgCtrlID(GetFocus)
   Control Get Text hDlg, cID To temp$
   i = ParseCount(temp$,$CrLf)
   ReDim tempList(i-1) As String
   Parse temp$, tempList(), $CrLf
End Sub

Sub RemoveDupes(Flag As Long)   '0 no sorting. 1 sorting
   MousePtr 11
   Local i,j,iCount,iMax As Long, temp$

   'put Source text into array Words()
   Control Get Text hDlg, %IDC_Source To temp$
   If CaseSensitive = 0 Then temp$ = LCase$(temp$)
   i = ParseCount(temp$,$CrLf)
   Dim Words(i-1) As String
   Parse temp$, Words(), $CrLf

   If Flag Then
      'Sorted
      Array Sort Words()
      For i = UBound(Words) To 1 Step -1   'zero based array
         If Words(i) = Words(i-1) Then Array Delete Words(i) : Incr iCount
      Next i
      ReDim Preserve Words(UBound(Words)-iCount)
   Else
      'Not sorted
      iMax = UBound(Words)
      For i = 0 To iMax-1
         For j = iMax To i+1 Step -1
            If Words(j) = Words(i) Then Array Delete Words(j) : Decr iMax
         Next j
      Next i
      ReDim Preserve Words(iMax)
   End If

   Control Set Text hDlg, %IDC_Results, Join$(Words(),$CrLf)
   MousePtr 1
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "logo"      '1
    ImageList Add Icon hImageList, "xpaste"    '2
    ImageList Add Icon hImageList, "xcopy"     '3
    ImageList Add Icon hImageList, "xsort"     '4
    ImageList Add Icon hImageList, "xhelp"     '5
    ImageList Add Icon hImageList, "xfont"     '6
    ImageList Add Icon hImageList, "xmatch"    '7
    ImageList Add Icon hImageList, "xlogo"     '8
    ImageList Add Icon hImageList, "xopen"     '9
    ImageList Add Icon hImageList, "xsaveas"   '10

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Paste,  %TbStyle_Button, "Paste"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Sort,  %TbStyle_Button, "Sort"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_DeDupe,  %TbStyle_Button, "DeDupe"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_DeDupeS,  %TbStyle_Button, "DeDupe"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_CopyAll,  %TbStyle_Button, "Copy All"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_SaveAs,  %TbStyle_Button, "SaveAs"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_CaseSensitive,  %TbStyle_Check, "Case Sensitive"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Font,  %TbStyle_Button, "Font"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Help,  %TbStyle_Button, "Help"
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_DeDupe     : Function = "Remove Duplicates (Maintain Order)"
      Case %IDT_DeDupeS    : Function = "Remove Duplicates (Sort Results)"
      Case %IDT_Paste      : Function = "Paste Clipboard to Source (Replace)"
      Case %IDT_Sort       : Function = "Sort Source"
      Case %IDT_CopyAll    : Function = "Copy All Results"
      Case %IDT_Font       : Function = "Open Select Font Dialog"
      Case %IDT_Match      : Function = "Case Sensitive Search"
      Case %IDT_Help       : Function = "Open Online Help"
      Case %IDT_Open       : Function = "Select Source Code File"
      Case %IDT_SaveAs     : Function = "Save Results to File"
      Case %IDT_CaseSensitive : Function = "Use Case-Sensitive Line Comparsion in DeDuping"
   End Select
End Function

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
      SetControlFonts
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub Settings_INI(Task$)
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "490", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "CFN", Exe.Path$ + Exe.Name$ + ".bas", CFN, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SearchString", "/", SearchString, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ReplaceString", $Spc, ReplaceString, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SplitString", "/", SplitString, %Max_Path, INIFileName
         If SplitString = "" Then SplitString = $Spc
      Getprivateprofilestring "All", "FileFilter", "*.bas;*.txt;*.htm;*.inc", FileFilter, %Max_Path, INIFileName
      Getprivateprofilestring "All", "AllowedChars", "#%-.:_$<>()" + Chr$(48 To 57,65 To 90,97 To 122), AllowedChars, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
      Getprivateprofilestring "All", "StartColumn", "1", temp, %Max_Path, INIFileName:  StartColumn = Val(temp)
      Getprivateprofilestring "All", "StopColumn", "10", temp, %Max_Path, INIFileName:  StopColumn = Val(temp)
      Getprivateprofilestring "All", "TruncatePos", "10", temp, %Max_Path, INIFileName:  TruncatePos = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "CFN",CFN, INIFileName
      WritePrivateProfileString "All", "SearchString",SearchString, INIFileName
      WritePrivateProfileString "All", "ReplaceString",ReplaceString, INIFileName
      WritePrivateProfileString "All", "SplitString",SplitString, INIFileName
      WritePrivateProfileString "All", "FileFilter",FileFilter, INIFileName
      WritePrivateProfileString "All", "AllowedChars",AllowedChars, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "StartColumn", (Str$(StartColumn)), INIFileName
      WritePrivateProfileString "All", "StopColumn", (Str$(StopColumn)), INIFileName
      WritePrivateProfileString "All", "TruncatePos", (Str$(TruncatePos)), INIFileName
   End If
End Sub

Function NewTBProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long, hChild As Dword, pt As Point
   Select Case Msg
      Case %WM_ContextMenu
         'give focus to textbox under cursor
         GetCursorPos pt
         ScreenToClient hDlg, pt
         hChild = ChildWindowFromPoint(hDlg,pt)
         SetFocus hChild
         'remove menu items not needed
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateContextMenus
   Menu New PopUp To hContext
   Menu Add String, hContext, "Copy" + $Tab + "Ctrl-C",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContext, "Cut" + $Tab + "Ctrl-X",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContext, "Paste" + $Tab + "Ctrl-V",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContext, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContext, "Clear", %IDM_Clear,  %MF_Enabled
   Menu Add String, hContext, "Clear Both", %IDM_ClearBoth,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Undo" + $Tab + "Ctrl-Z", %IDM_Undo,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Sort Ascending" + $Tab + "Ctrl-S", %IDM_SortA,  %MF_Enabled
   Menu Add String, hContext, "Sort Descending", %IDM_SortD,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Left Justify", %IDM_LeftJustify,  %MF_Enabled
   Menu Add String, hContext, "Remove Blank Lines" + $Tab + "Ctrl-B", %IDM_RemoveBlankLines,  %MF_Enabled
   Menu Add String, hContext, "Trim Trailing Spaces", %IDM_TrimRight,  %MF_Enabled
   Menu Add String, hContext, "Trim Leading/Trailing Spaces" + $Tab + "Ctrl-T", %IDM_Trim,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Upper Case", %IDM_UpperCase,  %MF_Enabled
   Menu Add String, hContext, "Lower Case", %IDM_LowerCase,  %MF_Enabled
   Menu Add String, hContext, "Mixed Case", %IDM_MixedCase,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Remove Extra Spaces", %IDM_RemoveExtraSpaces,  %MF_Enabled
   Menu Add String, hContext, "Remove Numbered Lines", %IDM_RemoveNumberedLines,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Number Lines", %IDM_NumberLines,  %MF_Enabled
   Menu Add String, hContext, "UnNumber Lines", %IDM_UnNumberLines,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Split Lines On Spaces", %IDM_SplitOnSpace,  %MF_Enabled
   Menu Add String, hContext, "Split Lines On String", %IDM_Split,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Replace non-Word Characters", %IDM_ReplaceNonWordChars,  %MF_Enabled
   Menu Add String, hContext, "Replace Text" + $Tab + "Ctrl-R", %IDM_Replace,  %MF_Enabled
   Menu Add String, hContext, "Delete Columns", %IDM_DeleteColumns,  %MF_Enabled
   Menu Add String, hContext, "Truncate Lines", %IDM_Truncate,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Edit Word Char List", %IDM_AllowedChars,  %MF_Enabled
End Sub

Sub SetMenusAndToolbar
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CaseSensitive, CaseSensitive * %TBState_Checked Or %TBState_Enabled
End Sub

Sub SetControlFonts
   Control Set Font hDlg, %IDC_Source, hFont
   Control Set Font hDlg, %IDC_Results, hFont
End Sub

Sub SaveSession
   Local temp$
   Control Get Text hDlg, %IDC_Source To temp$
   Open Exe.Path$ + Exe.Name$ + "_source.txt" For Output As #1
   Print #1, temp$;
   Close #1

   Control Get Text hDlg, %IDC_Results To temp$
   Open Exe.Path$ + Exe.Name$ + "_results.txt" For Output As #1
   Print #1, temp$;
   Close #1
End Sub

Sub LoadPreviousSession
    Local temp$, fName$
    fName$ = Exe.Path$ + Exe.Name$ + "_source.txt"
    If IsFile(fName$) Then
       Open fName$ For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       Control Set Text hDlg, %IDC_Source, temp$
    End If
    fName$ = Exe.Path$ + Exe.Name$ + "_results.txt"
    If IsFile(fName$) Then
       Open fName$ For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       Control Set Text hDlg, %IDC_Results, temp$
    End If
End Sub

Sub xManageScrollbars(cID As Long)
   Local hBMP As Dword, style&, temp$, tmp$
   Local MaxVisibleLines, i,LineCount,wMax,w,h,x,y,m,n As Long
   'use Graphic for getting text width and line to line dimensions
   Graphic Bitmap New 100,100 To hBMP : Graphic Attach hBMP, 0
   Graphic Set Font hFont
   Graphic Get Pos To x,y
   Graphic Print "ABC"      '<--- any text will be fine
   Graphic Get Pos To m,n   '<--- line to line is n-y
   LineCount = SendMessage(GetDlgItem(hDlg,cID), %EM_GetLineCount, 0,0)  'lines of text in the control
   Control Get Client hDlg, cID To w,h
   MaxVisibleLines = h / (n-y) - 1      'get # of lines that will fit
   ShowScrollbar GetDlgItem(hDlg,cID), %SB_Vert, IIf(LineCount > MaxVisibleLines, %True, %False)
   Control Get Text hDlg, cID To temp$
   For i = 1 To LineCount
      tmp$ = Parse$(temp$,$CrLf,i)
      Graphic Text Size tmp$ To x,y                    'width/height of text
      wMax = Max(wMax,x)                               'keep largest width
   Next i
   ShowScrollbar GetDlgItem(hDlg,cID), %SB_Horz, IIf(wMax > (w-10), %True, %False)
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(9)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd  = %IDT_Help      : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd  = %IDM_Replace   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_B  : ac(c).cmd  = %IDM_RemoveBlankLines : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd  = %IDT_DeDupeS   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M  : ac(c).cmd  = %IDM_MultiTask : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd  = %IDM_Replace   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd  = %IDT_Sort      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd  = %IDM_Trim      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Y  : ac(c).cmd  = %IDM_FakeData  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z  : ac(c).cmd  = %IDM_Undo      : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateFakeData
   Local temp$
   Static Flag As Long
   Incr Flag
   If Flag > 3 Then Flag = 1
   Select Case Flag
      Case 1
         temp$ = "D" + $CrLf + "C" + $CrLf + "B" + $CrLf + "A" + $CrLf + "A" + $CrLf
         temp$ = temp$ + "a" + $CrLf+ "a" + $CrLf+ "a" + $CrLf  + "b" + $CrLf  + "c" + $CrLf  + "d"
         Control Set Text hDlg, %IDC_Source, temp$
         Control Set Text hDlg, %IDC_Results, ""
      Case 2
         temp$ = " D" + $CrLf + "  C" + $CrLf + "   B" + $CrLf + " A" + $CrLf + " A" + $CrLf + $CrLf + " d" + $CrLf
         temp$ = temp$ + "    a" + $CrLf  + "   b" + $CrLf + "   b" + $CrLf  + $CrLf + "  c" + $CrLf  + " d"
         Control Set Text hDlg, %IDC_Source, temp$
         Control Set Text hDlg, %IDC_Results, ""
      Case 3
         temp$ = "1 DOG" + $CrLf + "  CaT" + $CrLf + "   boY" + $CrLf + " nest.ANt" + $CrLf + " nest.ANt" + $CrLf + $CrLf
         temp$ = temp$ + "    FOOT.ankle" + $CrLf  + "4   buns" + $CrLf  + "  chin" + $CrLf + "  cHIN" + $CrLf  + "6DoormaT"
         Control Set Text hDlg, %IDC_Source, temp$
         Control Set Text hDlg, %IDC_Results, ""
   End Select
   Control Set Focus hDlg, %IDC_Source
End Sub

Sub SaveAs
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, iResult&, temp$
    title$ = ""                'caption title. if "", then "Save As" is displayed
    startfolder$ = CFN  'initial folder to be displayed
    filter$ = "Text Files" + $Nul + ".txt" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfile$ = CFN    'name to be used as initial selection
    defaultext$ = "txt"        'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       Control Get Text hDlg, GetDlgCtrlID(GetFocus) To temp$
       CFN = filevar$
       Open CFN For Output As #1
       Print #1, temp$;
       Close #1
    End If
End Sub

Sub SortTextA
   MousePtr 11
   If CaseSensitive Then
      Array Sort tempList$(), Collate UCase
   Else
      Array Sort tempList$()
   End If
   Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)
   MousePtr 1
End Sub

Sub SortTextD
   MousePtr 11
   If CaseSensitive Then
      Array Sort tempList$(), Collate UCase, Descend
   Else
      Array Sort tempList$(), Descend
   End If
   Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)
   MousePtr 1
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "EDIT"   Then PostMessage(wParam, %EM_SetSel,0,0)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub RemoveBlankLines
   MousePtr 11
   Local i,iCount As Long, temp$
   BuildTempList
   For i = UBound(tempList) To 0 Step -1
      If Trim$(tempList(i)) = "" Then Array Delete tempList(i) : Incr iCount
   Next i
   If iCount Then
      ReDim Preserve tempList(UBound(tempList)-iCount)
      Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)
   End If
   MousePtr 1
End Sub

Sub RemoveNumberedLines
   MousePtr 11
   Local i,iCount As Long, temp$
   BuildTempList
   For i = UBound(tempList) To 0 Step -1
      If Len(tempList(i)) Then
         If InStr("0123456789",Left$(tempList(i),1)) Then Array Delete tempList(i) : Incr iCount
      End If
   Next i
   If iCount Then
      ReDim Preserve tempList(UBound(tempList)-iCount)
      Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)
   End If
   MousePtr 1
End Sub

Sub ReplaceTextString
   MousePtr 11
   Local w,h,i,iCount As Long, temp$
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Search/Replace String", SearchString + $Spc + ReplaceString,w+40,h+150)
   If Len(temp$) Then
      SearchString = Parse$(temp$,$Spc,1)
      ReplaceString = Parse$(temp$,$Spc,2)
   End If
   If Len(SearchString) = 0 Then Exit Sub
   Control Get Text hDlg, GetDlgCtrlID(GetFocus) To temp$
   Replace SearchString With ReplaceString In temp$
   Control Set Text hDlg, GetDlgCtrlID(GetFocus), temp$
   MousePtr 1
End Sub

Sub ReplaceNonWordChars
   MousePtr 11
   Local w,h,i,iCount As Long, temp$, BadChar As String
   BadChar = Remove$(Chr$(32 To 255), Any AllowedChars)
   Control Get Text hDlg, GetDlgCtrlID(GetFocus) To temp$
   Replace Any BadChar With Space$(Len(BadChar)) In temp$
   Control Set Text hDlg, GetDlgCtrlID(GetFocus), temp$
   MousePtr 1
End Sub

Sub DeleteColumns
   MousePtr 11
   Local w,h,i,iCount,iStart,iEnd As Long, temp$
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Start/Stop Column", Str$(StartColumn) + "," + Str$(StopColumn),w+40,h+150)
   If StartColumn = 0 Or StopColumn = 0 Then Exit Sub
   BuildTempList
   For i = UBound(tempList) To 0 Step -1
      tempList(i) = Left$(tempList(i),iStart-1) + Mid$(tempList(i),iEnd+1)
   Next i
   Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)
   MousePtr 1
End Sub

Sub NumberLines
   MousePtr 11
   Local w,h,i,iCount,iStart,iEnd As Long, temp$
   BuildTempList
   For i = 0 To UBound(tempList)
      tempList(i) = Format$(i,"00000 ") + tempList(i)
   Next i
   Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)
   MousePtr 1
End Sub

Sub UnNumberLines
   MousePtr 11
   Local w,h,i,iCount,iStart,iEnd As Long, temp$
   BuildTempList
   For i = 0 To UBound(tempList)
      tempList(i) = Mid$(tempList(i),7)
   Next i
   Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)
   MousePtr 1
End Sub

Sub TruncateLines
   MousePtr 11
   Local w,h,i,iCount,iPos As Long, temp$
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Truncate Lines At Column", Str$(TruncatePos),w+40,h+150)
   If Len(temp$) = 0 Then Exit Sub
   TruncatePos = Val(temp$)
   BuildTempList
   For i = 0 To UBound(tempList)
      tempList(i) = Left$(tempList(i),TruncatePos-1)
   Next i
   Control Set Text hDlg, GetDlgCtrlID(GetFocus), Join$(tempList(),$CrLf)
   MousePtr 1
End Sub

Sub SplitLines
   MousePtr 11
   Local w,h,i,iCount, cID As Long, temp$
   cID = GetDlgCtrlID(GetFocus)
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Split String", SplitString,w+40,h+150)
   If Len(temp$) = 0 Then Exit Sub
   SplitString = temp$
   Control Get Text hDlg, cID To temp$
   Replace SplitString With $CrLf In temp$
   Control Set Text hDlg, cID, temp$
   MousePtr 1
End Sub

Sub SplitLinesOnSpace
   MousePtr 11
   Local w,h,i,iCount, cID As Long, temp$
   cID = GetDlgCtrlID(GetFocus)
   Control Get Text hDlg, cID To temp$
   temp$ = Shrink$(temp$)
   Replace $Spc With $CrLf In temp$
   Control Set Text hDlg, cID, temp$
   MousePtr 1
End Sub

Sub SelectFile
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = "Text Files" + $Nul + FileFilter + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = (CFN)     'initial folder to be displayed
    startfile$ = (CFN)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then CFN = filevar$ : LoadFile
'    PostMessage GetDlgItem(hDlg, %IDC_RichEdit), %EM_SETSEL, -1, 0   'remove highlighting on cancel load
End Sub

Sub LoadFile
   Local temp$
   Open CFN For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   Control Set Text hDlg, %IDC_Source, temp$
End Sub

Sub DisplaySummary
   Local temp$, LinesSource, LinesResults As Long

   Control Get Text hDlg, %IDC_Source To temp$
   If Len(temp$) Then
      LinesSource = SendMessage(GetDlgItem(hDlg,%IDC_Source), %EM_GetLineCount, 0,0)  'lines of text in the control
   Else
      LinesSource = 0
   End If

   Control Get Text hDlg, %IDC_Results To temp$
   If Len(temp$) Then
      LinesResults = SendMessage(GetDlgItem(hDlg,%IDC_Results), %EM_GetLineCount, 0,0)  'lines of text in the control
   Else
      LinesResults = 0
   End If

   temp$ = "Source:" + Str$(LinesSource) + "   Results: " + Str$(LinesResults)
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, temp$
End Sub

Sub EditAllowedChars
   Local w,h As Long, temp$
   Dialog Get Loc hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Word Character List", AllowedChars,w+40,h+150)
   If Len(temp$) Then AllowedChars = temp$
End Sub

Sub SaveUndoText
   Select Case GetDlgCtrlID(GetFocus)
      Case %IDC_Source  : Control Get Text hDlg, %IDC_Source To UndoSource
      Case %IDC_Results : Control Get Text hDlg, %IDC_Results To UndoResults
   End Select
End Sub
